`timescale 1ps / 1ps

module clk_change_stage (
  clk2x,     clk, 
  Input_Data1,  Input_Data2,  Input_Data3, Input_Data4,
  Input_Data5,  Input_Data6,  Input_Data7, Input_Data8,
  Fib1BZero,    Fib2BZero,    Fib3BZero,   Fib4BZero, 
  Fib5BZero,    Fib6BZero,    Fib7BZero,   Fib8BZero,
  resetTP1,     resetTP2,     resetTP3,    resetTP4,
  resetTP5,     resetTP6,     resetTP7,    resetTP8, 
  QIE1data,   QIE2data,   QIE3data,   QIE4data,   QIE5data,  QIE6data,
  QIE7data,   QIE8data,   QIE9data,   QIE10data,  QIE11data, QIE12data,
  QIE13data,  QIE14data,  QIE15data,  QIE16data,  QIE17data, QIE18data,
  QIE19data,  QIE20data,  QIE21data,  QIE22data,  QIE23data, QIE24data    );
  
 
  input clk2x,        clk;
  input [17:0] Input_Data1,  Input_Data2,  Input_Data3, Input_Data4;
  input [17:0] Input_Data5,  Input_Data6,  Input_Data7, Input_Data8;
  output[10:0] QIE1data,   QIE2data,   QIE3data,   QIE4data,   QIE5data,  QIE6data;
  output[10:0] QIE7data,   QIE8data,   QIE9data,   QIE10data,  QIE11data, QIE12data;
  output[10:0] QIE13data,  QIE14data,  QIE15data,  QIE16data,  QIE17data, QIE18data;
  output[10:0] QIE19data,  QIE20data,  QIE21data,  QIE22data,  QIE23data, QIE24data;  
  output       Fib1BZero, Fib2BZero, Fib3BZero, Fib4BZero, 
               Fib5BZero, Fib6BZero, Fib7BZero, Fib8BZero;  //it's one BZero per fiber
  output       resetTP1, resetTP2, resetTP3, resetTP4,
               resetTP5, resetTP6, resetTP7, resetTP8;
  wire [17:0]  Input_Data1,  Input_Data2,  Input_Data3, Input_Data4;
  wire [17:0]  Input_Data5,  Input_Data6,  Input_Data7, Input_Data8;
  
  clk_change clk_change1
  (  .clk2x(clk2x),  .clk(clk),     
     .Input_Data(Input_Data1),                  .reset_TP(resetTP1),
     .BZero(Fib1BZero),    .FE_DataFlag(),      .FE_CntrlFlag(), 
     .QIE0data(QIE1data),  .QIE1data(QIE2data), .QIE2data(QIE3data) );

  clk_change clk_change2
  (  .clk2x(clk2x),  .clk(clk),     
     .Input_Data(Input_Data2),                  .reset_TP(resetTP2),
     .BZero(Fib2BZero),    .FE_DataFlag(),      .FE_CntrlFlag(), 
     .QIE0data(QIE4data),  .QIE1data(QIE5data), .QIE2data(QIE6data)  );

  clk_change clk_change3
  (  .clk2x(clk2x),  .clk(clk),
     .Input_Data(Input_Data3),                   .reset_TP(resetTP3),
     .BZero(Fib3BZero),    .FE_DataFlag(),       .FE_CntrlFlag(), 
     .QIE0data(QIE7data),  .QIE1data(QIE8data),  .QIE2data(QIE9data)  );

  clk_change clk_change4
  (  .clk2x(clk2x),  .clk(clk),
     .Input_Data(Input_Data4),                    .reset_TP(resetTP4),
     .BZero(Fib4BZero),     .FE_DataFlag(),       .FE_CntrlFlag(), 
     .QIE0data(QIE10data),  .QIE1data(QIE11data), .QIE2data(QIE12data)  );

  clk_change clk_change5
  (  .clk2x(clk2x),  .clk(clk),
     .Input_Data(Input_Data5),                    .reset_TP(resetTP5),
     .BZero(Fib5BZero),     .FE_DataFlag(),       .FE_CntrlFlag(), 
     .QIE0data(QIE13data),  .QIE1data(QIE14data), .QIE2data(QIE15data)  );

  clk_change clk_change6
  (  .clk2x(clk2x),  .clk(clk),
     .Input_Data(Input_Data6),                    .reset_TP(resetTP6),
     .BZero(Fib6BZero),     .FE_DataFlag(),       .FE_CntrlFlag(), 
     .QIE0data(QIE16data),  .QIE1data(QIE17data), .QIE2data(QIE18data)  );

  clk_change clk_change7
  (  .clk2x(clk2x),  .clk(clk),
     .Input_Data(Input_Data7),                    .reset_TP(resetTP7),
     .BZero(Fib7BZero),     .FE_DataFlag(),       .FE_CntrlFlag(), 
     .QIE0data(QIE19data),  .QIE1data(QIE20data), .QIE2data(QIE21data)  );

  clk_change clk_change8
  (  .clk2x(clk2x),  .clk(clk),
     .Input_Data(Input_Data8),                    .reset_TP(resetTP8),
     .BZero(Fib8BZero),     .FE_DataFlag(),       .FE_CntrlFlag(), 
     .QIE0data(QIE22data),  .QIE1data(QIE23data), .QIE2data(QIE24data)  );

endmodule