`timescale 1ns / 1ps

/* the following syntax avoids compiler warnings (Macro 'TEXT' redifined):
`ifndef  TEXT   `define TEXT  8  
`endif
*/

// *** INCREMENT HERE AT EVERY NEW VERSION:   ***
`ifndef  FPGAversionN              `define  FPGAversionN             2  
`endif

/*** VERSION TYPE AS FOLLOW:
3'b000   Versions before separation of HB-HO-HF
3'b001   Normal Beam firmware for HB/HE
3'b010   Normal Beam firmware for HO (+ HO trigger)
3'b011   Normal Beam firmware for HF (+ Luminosity)
3'b100   Source Calibration Histogramming firmware
3'b101   Reserved
3'b110   Reserved
3'b111   Testing and Hardware debugging
 ***/
`ifndef  FPGAversionType           `define  FPGAversionType       3'b111  
`endif

// INCREMENT HERE IF YOU CHANGE THE HTR/DCC FORMAT:
`ifndef  FORMAT_VERSION            `define  FORMAT_VERSION            0  
`endif

//  ********************************************************
// Other definitions
`ifndef  BCN_WIDTH                 `define  BCN_WIDTH                12  
`endif
`ifndef  COMPR_LUT_ADDR_WIDTH      `define  COMPR_LUT_ADDR_WIDTH     10  
`endif
`ifndef  COMPR_LUT_DATA_WIDTH      `define  COMPR_LUT_DATA_WIDTH      8
`endif
`ifndef  DAQ_MUX_SEL               `define  DAQ_MUX_SEL               6  
`endif
`ifndef  DEL_DATA_WIDTH            `define  DEL_DATA_WIDTH           18  
`endif
`ifndef  DRND_ADDR_WIDTH           `define  DRND_ADDR_WIDTH           9
`endif
`ifndef  EVN_WIDTH                 `define  EVN_WIDTH                24
`endif
`ifndef  HCN_WIDTH                 `define  HCN_WIDTH                10  
`endif
`ifndef  MAIN_DATA_WIDTH           `define  MAIN_DATA_WIDTH          16  
`endif
`ifndef  OrN_WIDTH                 `define  OrN_WIDTH                 8 
`endif
`ifndef  QIEDATA_WIDTH             `define  QIEDATA_WIDTH             7
`endif
`ifndef  INPUT_LUT_ADDR_WIDTH      `define  INPUT_LUT_ADDR_WIDTH      7
`endif
`ifndef  INPUT_LUT_DATA_WIDTH      `define  INPUT_LUT_DATA_WIDTH     11
`endif
`ifndef  INPUT_LUT_DEPTH           `define  INPUT_LUT_DEPTH         128
`endif
`ifndef  LB_Addr_Size              `define  LB_Addr_Size             21
`endif
`ifndef  NTT                       `define  NTT                      24
`endif
`ifndef  OUTPUT_LUT_DEPTH          `define  OUTPUT_LUT_DEPTH       1024
`endif
`ifndef  REG_WIDTH                 `define  REG_WIDTH                19
`endif  // if changed: arrange LocBusSlave iobuf's
`ifndef  TRIGGER_PATH_DATA_WIDTH   `define  TRIGGER_PATH_DATA_WIDTH   9  
`endif
`ifndef  SpyFIFO_WIDTH             `define  SpyFIFO_WIDTH            18  
`endif


/* NB: after introducing this file, the other *.v files sometimes were
not recognized as verilog modules by ISE. Editing and saving them
usually fix the problem */
